import{handleMissingValue}from"./missing.js";



export const expandTokens=function(entries,index,opts){
return entries.
filter(({queryArray})=>queryArray.length!==index).
flatMap((entry)=>expandToken(entry,index,opts));
};


const expandToken=function({queryArray,value,path},index,opts){
const token=queryArray[index];
const missingReturn=handleMissingValue(value,token,opts.classes);
const childEntriesA=iterateToken(token,missingReturn,opts);
return childEntriesA.
filter(isAllowedEntry).
map(({value:childValue,prop,missing:missingEntry})=>({
queryArray,
value:childValue,
path:[...path,prop],
missing:missingReturn.missing||missingEntry}));

};

const isAllowedEntry=function({prop}){
return isAllowedProp(prop);
};


export const isAllowedProp=function(prop){
return!FORBIDDEN_PROPS.has(prop);
};

const FORBIDDEN_PROPS=new Set(["__proto__","prototype","constructor"]);

const iterateToken=function(
token,
{tokenType,missing:missingParent,value},
{inherited,missing:includeMissing})
{
if(includeMissing){
return tokenType.iterate(value,token,inherited);
}

if(missingParent){
return[];
}

const childEntries=tokenType.iterate(value,token,inherited);
return childEntries.filter(isNotMissing);
};

const isNotMissing=function({missing}){
return!missing;
};
//# sourceMappingURL=expand.js.map