import{getTokenType}from"../tokens/main.js";

import{isObject,isWeakObject}from"./object.js";


















export const getMissingValue=function(value,prop,{missing,classes}){
return missing?handleMissingValue(value,prop,classes).value:value;
};

export const handleMissingValue=function(value,token,classes){
const tokenType=getTokenType(token);
const{isPresent,getDefaultValue}=MISSING_HANDLERS[tokenType.valueType];
const missing=!isPresent(value,classes);
const valueA=missing?getDefaultValue():value;
return{tokenType,missing,value:valueA};
};



const getDefaultObject=function(){
return{};
};

const getDefaultArray=function(){
return[];
};

export const MISSING_HANDLERS={
objectArray:{
isPresent(value,classes){
return isObject(value,classes)||Array.isArray(value);
},
getDefaultValue:getDefaultObject},

array:{
isPresent:Array.isArray,
getDefaultValue:getDefaultArray},

strictObject:{
isPresent(value,classes){
return isObject(value,classes);
},
getDefaultValue:getDefaultObject},

weakObject:{
isPresent:isWeakObject,
getDefaultValue:getDefaultObject}};
//# sourceMappingURL=missing.js.map